/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             Interface to ListX
*  SCOPE :              Interface to ListX
*  FILE :               listx_tmpl.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif
#ifndef __listx_tmpl_HXX
#define __listx_tmpl_HXX

/* IMPORTS *******************************************************************/

#ifndef __listx_HXX
#include "listx.hxx"
#endif

/*****************************************************************************/


template <class Ptr> class LocalListX : public LocalListXObjectX {

public :

  LocalListX() {} ;
  LocalListX(const LocalListX<Ptr>& l) { *this = l ; } 

  LocalListX<Ptr>& operator=(const LocalListX<Ptr>& s) {
    this->assign(s) ; return *this ;
  }

  LocalListX<Ptr>& operator+=(const LocalListX<Ptr>& s) {
    this->append(s) ; return *this ;
  }

  LocalListX<Ptr>& operator+=(Ptr* el) {
    this->append(el) ; return *this ;
  }

  int operator==(const LocalListX<Ptr>& s) {
    return this->compare(s) ;
  }

  int operator!=(const LocalListX<Ptr>& s) {
    return ! this->compare(s) ;
  }

  int member(Ptr* obj) {
    return this->LocalListXObjectX::member(obj) ;
  }

  void insert(Ptr* el, int pos) {
    this->LocalListXObjectX::insert(el, pos) ;
  }

  Ref<Ptr>& operator[](int ind) {
    return *(Ref<Ptr>*)this->getElem(ind) ;
  }
} ;


template <class ELEM> class ListX : public ObjectX , public LocalListX<ELEM> {

 public :
   ListX() {} ;
   ListX(const LocalListX<ELEM>& l) { *this = l ; } 

   ListX<ELEM>& operator=(const LocalListX<ELEM>& s) {
     this->assign(s) ; return *this ;
   }

   static void* operator new(size_t s, Cluster* clu=YOO_DEF_CLU) { 
     return ObjectX::operator new(s, clu, UNTYPED) ;
   }

   static void* operator new(size_t s, ObjectX* obj) {
     return ObjectX::operator new(s, obj, UNTYPED) ;
   }
} ;


#endif
